unit Zoomfrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, CAD2DCmp, GrLib2D;

type
  TZoomForm = class(TForm)
    ViewPort1: TViewPort;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ViewPort1MouseUp2D(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; WX, WY: Single);
    procedure ViewPort1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ViewPort1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    InSelect: Boolean;
    BeginArea: TPoint2D;
  public
    { Public declarations }
    HasChanged: Boolean;
    ZoomRect: TRect2D;
  end;

var
  ZoomForm: TZoomForm;

implementation

uses CADFrm;
{$R *.DFM}

procedure TZoomForm.FormCreate(Sender: TObject);
begin
  Viewport1.CADCmp2D := CADForm.CADCmp1;
  HasChanged := True;
end;

procedure TZoomForm.FormActivate(Sender: TObject);
begin
  InSelect := False;
  if not HasChanged then Exit;
  Screen.Cursor := crHourGlass;
  try
    CADForm.CADCmp1.UpdateExtension;
    Viewport1.GridStep := CADForm.Viewport1.GridStep;
    Viewport1.ZoomExtension;
    Viewport1.ZoomOut;
    HasChanged := False;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TZoomForm.ViewPort1MouseUp2D(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; WX, WY: Single);
begin
   if InSelect then
    begin
      ZoomRect.FirstEdge := Viewport1.ViewToWorld(BeginArea);
      ZoomRect.SecondEdge := Point2D(WX, WY);
      Close;
    end;
end;

procedure TZoomForm.ViewPort1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not InSelect then
   begin
     BeginArea := Point2D(X, Y);
     InSelect := True;
   end;
end;

procedure TZoomForm.ViewPort1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if InSelect then
   begin
     Viewport1.Refresh;
     Viewport1.Canvas.Pen.Style := psDot;
     Viewport1.Canvas.Pen.Width := 2;
     Viewport1.Canvas.Pen.Mode := pmXOr;
     Viewport1.Canvas.Pen.Color := clGray;
     Viewport1.Canvas.MoveTo(Trunc(BeginArea.X), Trunc(BeginArea.Y));
     Viewport1.Canvas.LineTo(Trunc(BeginArea.X), Y);
     Viewport1.Canvas.LineTo(X, Y);
     Viewport1.Canvas.LineTo(X, Trunc(BeginArea.Y));
     Viewport1.Canvas.LineTo(Trunc(BeginArea.X), Trunc(BeginArea.Y));
   end;
end;

end.
